Subject: Re: [Intel-wired-lan] [PATCH iwl-next v4 0/5] iavf: Add devlink and devlink rate support'

From: Jakub Kicinski <[email-masked]>
Date: Mon, 27 Nov 2023 17:43:29 -0800

On Mon, 27 Nov 2023 16:15:47 -0800 Zhang, Xuejun wrote:
> This is extension of ndo_set_tx_maxrate to include per queue parameters 
> of tx_minrate and burst.
> 
> devlink rate api includes tx_maxrate and tx_minrate, it is intended for 
> port rate configurations.
> 
> With regarding to tc mqprio, it is being used to configure queue group 
> per tc.
> 
> For sriov ndo ndo_set_vf_rate, that has been used for overall VF rate 
> configuration, not for queue based rate configuration.
> 
> It seems there are differences on intent of the aforementioned APIs.
> 
> Our use case here is to allow user (i.e @ uAPI) to configure tx rates of 
> max rate & min rate per VF queue.Hence we are inclined to 
> ndo_set_tx_maxrate extension.

I said:

  So since you asked for my opinion - my opinion is that step 1 is to
  create a common representation of what we already have and feed it
  to the drivers via a single interface. I could just be taking sysfs
  maxrate and feeding it to the driver via the devlink rate interface.
  If we have the right internals I give 0 cares about what uAPI you pick.

https://lore.kernel.org/all/[email-masked]/

Again, the first step is creating a common kernel <> driver interface
which can be used to send to the driver the configuration from the
existing 4 interfaces.